Global resX = 1024, resY = 768
Graphics3D resX,resY,32,2
SetBuffer BackBuffer() ; DoubeBuffering
AppTitle "ModelFramer -- BCC54 -- by V.B."

;Timer
Global Timer  = CreateTimer(60) ; 60 FPS (Bilder pro Sekunde)

;Hauptschleifen Locals
Local wfon, ms, fps

;Maus
Global msxs, msys, mszs, MausX, MausY, Maus1Hit, Maus2Hit, Maus1Down, Maus2Down

;Camera
Global cam_y_piv = CreatePivot() 			;yaw
Global cam_x_piv = CreatePivot(cam_y_piv)
Global cam_z_piv = CreatePivot(cam_x_piv) 	;roll
RotateEntity cam_y_piv,0,-180,0 			;Auto von Hinten darstellen
Global cam = CreateCamera(cam_z_piv) 		;Camera
CameraRange cam, 1, 10000					;Sichtweite
PositionEntity cam_z_piv,0,0,-60

;Light
Local light = CreateLight()

MoveEntity light, 0, 10, 0
RotateEntity light, -90, 0, 0

Global caml = CreateLight()

;const paths
Const mdlpath$ = "mdl\fig005.b3d"
Const imgpath$ = "tiledIMG.bmp"
Const imgpath2$ = "OneShotIMG.bmp"
Const backpath$ = "img\Moss.bmp"

;Global ImageVars
Global picW = 64
Global picH = 64
Const sides = 8 ;n, ne, e, se, s, sw, w, nw
Global vorschauHandle, vorschauHandle2, vorschauFrame, vorschauCount

;Model
Global meshpiv = CreatePivot()
Global mesh
Global meshScale#[3]
meshScale[0] = 1
meshScale[1] = 1
meshScale[2] = 1
reloadModel()

;Switches
Global S_camPitch = 0, S_camYaw, S_info = 0, S_animate = 0, S_picFrames, S_captureAll, S_meshScale, S_vorschau = 0, S_frameSize = 0, S_gotoFrame = 0
Global camPitch, camYaw, camDistance, picFrames=6, captureAll

Global camMode = 1, orthoZoom#, gotoFrame ; 2=ortho

;Texture index
Global I_kopf = 1, I_hals = 1, I_bauch = 1, I_arm = 1, I_hand = 1, I_hose = 1, I_bein = 1, I_fuss = 1

;--------------------
; Anfang der Hauptschleife

Repeat
	
	;Maus Variablen Updaten
	msxs = MouseXSpeed()
	msys = MouseYSpeed()
	mszs = MouseZSpeed()
	
	MausX = MouseX()
	MausY = MouseY()
	
	Maus1Hit = MouseHit(1)
	Maus2Hit = MouseHit(2)
	Maus1Down = MouseDown(1)
	Maus2Down = MouseDown(2)
	
	;Functions
	move_camera()
	
	If S_animate = 1 Then UpdateWorld()
	RenderWorld()
	
	menu()
	
	If (MilliSecs()-ms) > 0
		fps = Int(1000/(MilliSecs()-ms))
		ms = MilliSecs() 
	EndIf
	
	WaitTimer(Timer) ; 60Fps
	
	Flip(0)
	
	;Wireframe
	If KeyHit(50) ;m
		wfon = Abs(wfon - 1)
		WireFrame(wfon)
	EndIf
	
Until KeyHit(1)
End

; Ende der Hauptschleife
;--------------------

Function move_camera()
	
	Local zsp#
	
	;--Cam Modus ndern
	If camMode = 1 Then 		;Stelle perspective ein
		CameraZoom cam, 1		;Reset von zoom
		CameraProjMode cam, 1 	;persp
		camMode = 3 			;Bleibe in perspective
	ElseIf camMode = 2 Then		;Stelle ortho ein
		orthoZoom = -17
		CameraZoom cam, 1+(0.05*orthoZoom)
		CameraProjMode cam, 2 	;ortho
		camMode = 4				;Bleibe in ortho
	ElseIf camMode = 3 Then 	;persp
		If KeyDown(42) Then zsp = 10 Else zsp = 1
		MoveEntity cam_z_piv,0,0,mszs*zsp
	ElseIf camMode = 4 Then 	;ortho
		If KeyDown(42) Then zsp = 1 Else zsp = .1
		orthoZoom# = orthoZoom# + mszs*zsp
		CameraZoom cam, 1+(0.05*orthoZoom)
	EndIf
	;--
	
	If Maus1Down 
		TurnEntity cam_y_piv,0,-msxs*0.5,0 ;yaw rotation
		TurnEntity cam_x_piv,msys*0.5,0,0 ;pitch rotation
	EndIf
	
	PositionEntity cam_y_piv, EntityX(meshpiv,1), EntityY(meshpiv,1)+MeshHeight(mesh)/2, EntityZ(meshpiv,1)
	
	;light der cam
	PositionEntity caml,EntityX(cam,1),EntityY(cam,1),EntityZ(cam,1)
	PointEntity caml, mesh
	
End Function

;--------------------

Function menu()
	
;2-D Sachen
	
;Rahmen
	Local rDist = 400
	Rect resX/2-rDist/2, resY/2-rDist/2, rDist, 5 	;nw: e
	Rect resX/2-rDist/2, resY/2-rDist/2, 5, rDist	;nw: s
	Rect resX/2+rDist/2, resY/2-rDist/2, 5, rDist	;ne: s
	Rect resX/2-rDist/2, resY/2+rDist/2, rDist+5, 5	;sw: e
	
	Local posX, posY, title$, camTitle$
	If camMode = 3 Then camTitle$ = "perspective" Else camTitle$ = "ortho"
	
;Info
	posX = 10
	posY = 10
	title$ = "info"
	txtButton(title$, posX, posY)
	
	If Maus1Hit And MausX > posX And MausX < (posX + StringWidth(title$) + 2) And MausY > posY And MausY < (posY + 14) Then S_info = Abs(S_info-1)
	If S_info = 1
		;Text
		Text 10 + 100, posY + 15 * 0, "meshhandle: " + meshpiv
		Text 10 + 100, posY + 15 * 1, "Camera: " + camTitle$
		Text 10 + 100, posY + 15 * 2, "S_animate: " + S_animate
		Text 10 + 100, posY + 15 * 3, "meshScale X: " + meshScale[0] + " meshScale Y: " + meshScale[1] + " meshScale Z: " + meshScale[2]
		Text 10 + 100, posY + 15 * 4, "Tries: " + TrisRendered()
		Text 10 + 100, posY + 15 * 5, "picFrames: " + picFrames
		Text 10 + 100, posY + 15 * 6, "MeshHeight(mesh): " + MeshHeight(mesh)
		Text 10 + 100, posY + 15 * 7, "frameSize Width: " + picW + " frameSize Height: " + picH
		Text 10 + 100, posY + 15 * 8, "camYaw: " + camYaw + " camPitch: " + camPitch
	EndIf
	
	
;animate
	posX = 10
	posY = 30
	title$ = "animate"
	txtButton(title$, posX, posY)
	
	If Maus1Hit And MausX > posX And MausX < (posX + StringWidth(title$) + 2) And MausY > posY And MausY < (posY + 14) Then 
		If S_animate = 0 Then 
			Animate mesh,1,.5,1: S_animate = 1
		ElseIf S_animate = 1 Then 
			Animate mesh,0,1,1: S_animate = 0
		EndIf
	EndIf
	
	
;S_meshScale
	posX = 10
	posY = 50
	title$ = "meshScale"
	txtButton(title$, posX, posY)
	
	If (S_meshScale = 0 Or S_meshScale = 4) And Maus1Hit And MausX > posX And MausX < (posX + StringWidth(title$) + 2) And MausY > posY And MausY < (posY + 14) Then FlushKeys: S_meshScale = 1
	Locate posX + StringWidth(title$) + 10, posY
	If S_meshScale = 1
		meshScale[0] = Input("meshScale X: ")
		If KeyHit(28)
			S_meshScale = 3 ;2  --> y nicht neu setzen da das Mesh sonst nicht im Framefocus liegt
			FlushKeys
		EndIf
	EndIf
;	Locate 10 + StringWidth("meshScale") + 10, 140
;	If S_meshScale = 2
;		meshScale[1] = Input("meshScale Y: ")
;		If KeyHit(28)
;			S_meshScale = 3
;			FlushKeys
;		EndIf
;	EndIf
	Locate posX + StringWidth(title$) + 10, posY+10
	If S_meshScale = 3
		meshScale[2] = Input("meshScale Z: ")
		If KeyHit(28)
			ScaleEntity mesh, meshScale[0], meshScale[1], meshScale[2], 1
			S_meshScale = 4
			FlushKeys
		EndIf
	EndIf
	
	
;camera
	posX = 10
	posY = 90
	title$ = "camera"
	txtButton(title$, posX, posY)
	
	If Maus1Hit And MausX > posX And MausX < (posX + StringWidth(title$) + 2) And MausY > posY And MausY < (posY + 14) Then 
		If camMode = 3 Then ;pers
			camMode = 2 ;ortho
		ElseIf camMode = 4 Then ;ortho
			camMode = 1 ;pers
		EndIf
	EndIf	
	
	
;camPitch
	posX = 10
	posY = 110
	title$ = "camPitch"
	txtButton(title$, posX, posY)
	
	If (S_camPitch = 0 Or S_camPitch = 2) And Maus1Hit And MausX > posX And MausX < (posX + StringWidth(title$) + 2) And MausY > posY And MausY < (posY + 14) Then FlushKeys: S_camPitch = 1
	Locate posX + StringWidth(title$) + 10, posY
	If S_camPitch = 1
		camPitch = Input("camPitch: ")
		If KeyHit(28)
			RotateEntity cam_x_piv, camPitch, 0, 0, 0
			S_camPitch = 2
			FlushKeys
		EndIf
	EndIf
	
	camPitch = EntityPitch(cam_x_piv,1)
	
	
;camYaw
	posX = 10
	posY = 130
	title$ = "camYaw"
	txtButton(title$, posX, posY)
	
	If (S_camYaw = 0 Or S_camYaw = 2) And Maus1Hit And MausX > posX And MausX < (posX + StringWidth(title$) + 2) And MausY > posY And MausY < (posY + 14) Then FlushKeys: S_camYaw = 1
	Locate posX + StringWidth(title$) + 10, posY
	If S_camYaw = 1
		camYaw = Input("camYaw: ")
		If KeyHit(28)
			RotateEntity cam_y_piv, 0, camYaw, 0, 1
			S_camYaw = 2
			FlushKeys
		EndIf
	EndIf
	
	camYaw = EntityYaw(cam_y_piv,1)
	
	
;frameSize
	posX = 10
	posY = 170
	title$ = "frameSize"
	txtButton(title$, posX, posY)
	
	If (S_frameSize = 0 Or S_frameSize = 3) And Maus1Hit And MausX > posX And MausX < (posX + StringWidth(title$) + 2) And MausY > posY And MausY < (posY + 14) Then FlushKeys: S_frameSize = 1
	Locate posX + StringWidth(title$) + 10, posY
	If S_frameSize = 1
		picW = Input("frameSize Width: ")
		If KeyHit(28)
			S_frameSize = 2
			FlushKeys
		EndIf
	EndIf
	Locate posX + StringWidth(title$) + 10, posY+10
	If S_frameSize = 2
		picH = Input("frameSize Height: ")
		If KeyHit(28)
			S_frameSize = 3
			FlushKeys
		EndIf
	EndIf
	
	
;picFrames
	posX = 10
	posY = 190
	title$ = "picFrames"
	txtButton(title$, posX, posY)
	
	If (S_picFrames = 0 Or S_picFrames = 2) And Maus1Hit And MausX > posX And MausX < (posX + StringWidth(title$) + 2) And MausY > posY And MausY < (posY + 14) Then FlushKeys: S_picFrames = 1
	Locate posX + StringWidth(title$) + 10, posY
	If S_picFrames = 1
		picFrames = Input("picFrames: ")
		If KeyHit(28)
			;Calculate Frames to screen
			S_picFrames = 2
			FlushKeys
		EndIf
	EndIf
	
	
;gotoFrame
	posX = 10
	posY = 210
	title$ = "gotoFrame"
	txtButton(title$, posX, posY)
	
	If (S_gotoFrame = 0 Or S_gotoFrame = 2) And Maus1Hit And MausX > posX And MausX < (posX + StringWidth(title$) + 2) And MausY > posY And MausY < (posY + 14) Then FlushKeys: S_gotoFrame = 1
	Locate 10 + StringWidth(title$) + 10, posY
	If S_gotoFrame = 1
		gotoFrame = Input("gotoFrame: ")
		If KeyHit(28)
			;Calculate Frames to screen
			S_gotoFrame = 2
			FlushKeys
		EndIf
		
		Animate mesh,0,1,1 ;stoppe animation
		Animate mesh,3
		
		For i=0 To (gotoFrame-1)
			UpdateWorld()
			RenderWorld()
		Next
	EndIf
	
	
;captureThis
	posX = 10
	posY = 250
	title$ = "captureThis"
	txtButton(title$, posX, posY)
	
	If Maus1Hit And MausX > posX And MausX < (posX + StringWidth(title$) + 2) And MausY > posY And MausY < (posY + 14) Then createShots(0)
	
	
;captureAll
	posX = 10
	posY = 270
	title$ = "captureAll"
	txtButton(title$, posX, posY)
	
	If Maus1Hit And MausX > posX And MausX < (posX + StringWidth(title$) + 2) And MausY > posY And MausY < (posY + 14) Then createShots(picFrames)
	
	
;Texturierung
	txtButton("Kopf", 10, 310)
	txtButton("Hals", 10, 330)
	txtButton("Bauch", 10, 350)
	txtButton("Arm", 10, 370)
	txtButton("Hand", 10, 390)
	txtButton("Hose", 10, 410)
	txtButton("Bein", 10, 430)
	txtButton("Fuss", 10, 450)
	
	
;vorschau
	
	posX = 150
	posY = 200
	
	If S_vorschau = 0 Then
		If vorschauHandle <> 0 Then FreeImage vorschauHandle: vorschauHandle = 0
		If vorschauHandle2 <> 0 Then FreeImage vorschauHandle2: vorschauHandle2 = 0
	EndIf
	
	If S_vorschau = 1 Then
		vorschauHandle = LoadAnimImage(imgpath$, picW, picH, 0, sides*picFrames )
		vorschauHandle2 = LoadImage(backpath$): ResizeImage vorschauHandle2, picW*2, picH*2
		MaskImage vorschauHandle,0,0,0
		S_vorschau = 2
	EndIf
	
	If S_vorschau = 2 Then
		DrawImage vorschauHandle2,posX-picW/2, posY-picH/2
		DrawImage vorschauHandle,posX, posY, vorschauFrame
		
		If vorschauCount = 0 Then ;Framebremse
			vorschauFrame = vorschauFrame + 1
			If vorschauFrame >= sides*picFrames Then vorschauFrame = 0
			vorschauCount = 5 ;Aller 5 Durchlufe neues  Frame
		EndIf
		vorschauCount = vorschauCount -1
	EndIf
	
	If S_vorschau = 3 Then
		vorschauHandle = LoadImage(imgpath2$)
		vorschauHandle2 = LoadImage(backpath$): ResizeImage vorschauHandle2, picW*2, picH*2
		MaskImage vorschauHandle,0,0,0
		S_vorschau = 4
	EndIf
	
	If S_vorschau = 4 Then
		DrawImage vorschauHandle2,posX-picW/2, posY-picH/2
		DrawImage vorschauHandle,posX, posY
	EndIf
	
End Function

;--------------------

Function farbe(index$)
	
	Select index$
		Case "weiss": Color 255, 255, 255
		Case "gelb": Color 230, 230, 50
		Case "pointer": Color 200, 200, 200
		Case "hell": Color 188, 188, 188
		Case "mittel": Color 125, 125, 125
		Case "dunkel": Color 68, 68, 68
		Case "beige": Color 172, 164, 112
	End Select
	
End Function

;--------------------

Function createShots(picFrames = 5) ;picFrames = 0 bedeudet Nur ein Bild machen
	
	Local count = 0
	Local rDist = 400 ;Rahmen
	Local i, i2, tmpScreen
	Local screen, screen2
	
	S_vorschau = 0: FreeImage vorschauHandle
	
	If picFrames > 0 Then
		
		If S_captureAll = 0 Then Animate mesh,0,1,1: S_animate = 0: S_captureAll = 1 ;Halte die Animation an
		
		RotateEntity cam_y_piv, 0, 0, 0, 1 ;Setze Yaw der Cam zurck
		PositionEntity caml,EntityX(cam,1),EntityY(cam,1),EntityZ(cam,1): PointEntity caml, mesh ;Licht der Cam
		screen=CreateImage(picW*picFrames,picH*sides,sides*picFrames) ;Lege ein resized Image an
		screen2=CreateImage(rDist,rDist) ;Lege ein rDist Image an
		
		For i=0 To (sides-1)
			Animate mesh,3,(Float(AnimLength(mesh))/picFrames),1
			
			For i2=0 To (picFrames-1)
				UpdateWorld()
				RenderWorld()
				count = count + 1
				
				CopyRect(resX/2-rDist/2, resY/2-rDist/2, rDist, rDist, 0, 0, FrontBuffer, ImageBuffer(screen2))
				tmpScreen = CopyImage(screen2)
				ResizeImage tmpScreen, picW, picH
				CopyRect(0, 0, picW, picH, picW*i2, picH*i, ImageBuffer(tmpScreen), ImageBuffer(screen))
				FreeImage(tmpScreen)
				progressBar(sides*picFrames, count, "Capture...")
			Next
			TurnEntity cam_y_piv, 0, 45, 0 ;Setze Yaw der Cam weiter
			PositionEntity caml,EntityX(cam,1),EntityY(cam,1),EntityZ(cam,1): PointEntity caml, mesh ;Licht der Cam
		Next
		
		progressBar(sides*picFrames, sides*picFrames/2, "Saving...")
		SaveImage(screen,imgpath$)
		S_vorschau = 1
		
	ElseIf picFrames = 0 Then
		
		RenderWorld()
		screen=CreateImage(picW,picH,1) ;Lege ein resized Image an
		screen2=CreateImage(rDist,rDist) ;Lege ein rDist Image an
		CopyRect(resX/2-rDist/2, resY/2-rDist/2, rDist, rDist, 0, 0, FrontBuffer, ImageBuffer(screen2))
		tmpScreen = CopyImage(screen2)
		ResizeImage tmpScreen, picW, picH
		CopyRect(0, 0, picW, picH, 0, 0, ImageBuffer(tmpScreen), ImageBuffer(screen))
		FreeImage(tmpScreen)
		SaveImage(screen,imgpath2$)
		Flip(0)
		S_vorschau = 3
		
	EndIf
	
	FreeImage(screen)
	FreeImage(screen2)
	
End Function

;--------------------

Function swapTexture(part$, direction)
	
	Local cpfsrc$ ;sourcePath
	Local cpfdes$ ;destinationPath
	Local fo ;FileHandle
	
	Local ctxtpath$ = "configTxt" 
	If FileType (ctxtpath$) = 0 Then ;erstelle ConfigDatei fr Texturen
		fo = WriteFile(ctxtpath$)
		WriteInt( fo, I_kopf ) ;kopf
		WriteInt( fo, I_bauch ) ;bauch
		WriteInt( fo, I_hose ) ;hose
		WriteInt( fo, I_bein ) ;bein
		WriteInt( fo, I_arm ) ;arm
		WriteInt( fo, I_hand ) ;hand
		WriteInt( fo, I_fuss ) ;fuss
		WriteInt( fo, I_hals ) ;hals
		CloseFile(fo)
	EndIf
	
	fo = ReadFile(ctxtpath$) ;lese ConfigDatei fr Texturen
		I_kopf = ReadInt(fo) 
		I_bauch = ReadInt(fo) 
		I_hose = ReadInt(fo) 
		I_bein = ReadInt(fo) 
		I_arm = ReadInt(fo) 
		I_hand = ReadInt(fo) 
		I_fuss = ReadInt(fo) 
		I_hals = ReadInt(fo) 
		CloseFile(fo)
	
	fo = OpenFile(ctxtpath$) ;berschreibe ConfigDatei fr Texturen
	Select part$
		Case "Kopf": 
			I_kopf = I_kopf + direction
			If I_kopf = 0 Then I_kopf = 11
			If I_kopf = 12 Then I_kopf = 1
			cpfsrc$ = "mdl\kopf" + I_kopf + ".jpg"
			cpfdes$ = "mdl\kopf" + "UVt.jpg"
			SeekFile( fo, 0 )
			WriteInt( fo, I_kopf )
		Case "Bauch":
			I_bauch = I_bauch + direction
			If I_bauch = 0 Then I_bauch = 7
			If I_bauch = 8 Then I_bauch = 1
			cpfsrc$ = "mdl\bauch" + I_bauch + ".jpg"
			cpfdes$ = "mdl\bauch" + "UVt.jpg"
			SeekFile( fo, 4 )
			WriteInt( fo, I_bauch )
		Case "Hose":
			I_hose = I_hose + direction
			If I_hose = 0 Then I_hose = 4
			If I_hose = 5 Then I_hose = 1
			cpfsrc$ = "mdl\hose" + I_hose + ".jpg"
			cpfdes$ = "mdl\hose" + "UVt.jpg"
			SeekFile( fo, 8 )
			WriteInt( fo, I_hose )
		Case "Bein":
			I_bein = I_bein + direction
			If I_bein = 0 Then I_bein = 5
			If I_bein = 6 Then I_bein = 1
			cpfsrc$ = "mdl\bein" + I_bein + ".jpg"
			cpfdes$ = "mdl\bein" + "UVt.jpg"
			SeekFile( fo, 12 )
			WriteInt( fo, I_bein )
		Case "Arm":
			I_arm = I_arm + direction
			If I_arm = 0 Then I_arm = 5
			If I_arm = 6 Then I_arm = 1
			cpfsrc$ = "mdl\arm" + I_arm + ".jpg"
			cpfdes$ = "mdl\arm" + "UVt.jpg"
			SeekFile( fo, 16 )
			WriteInt( fo, I_arm )
		Case "Hand":
			I_hand = I_hand + direction
			If I_hand = 0 Then I_hand = 4
			If I_hand = 5 Then I_hand = 1
			cpfsrc$ = "mdl\hand" + I_hand + ".jpg"
			cpfdes$ = "mdl\hand" + "UVt.jpg"
			SeekFile( fo, 20 )
			WriteInt( fo, I_hand )
		Case "Fuss":
			I_fuss = I_fuss + direction
			If I_fuss = 0 Then I_fuss = 4
			If I_fuss = 5 Then I_fuss = 1
			cpfsrc$ = "mdl\fuss" + I_fuss + ".jpg"
			cpfdes$ = "mdl\fuss" + "UVt.jpg"
			SeekFile( fo, 24 )
			WriteInt( fo, I_fuss )
		Case "Hals":
			I_hals = I_hals + direction
			If I_hals = 0 Then I_hals = 2
			If I_hals = 3 Then I_hals = 1
			cpfsrc$ = "mdl\hals" + I_hals + ".jpg"
			cpfdes$ = "mdl\hals" + "UVt.jpg"
			SeekFile( fo, 28 )
			WriteInt( fo, I_hals )
	End Select
	CloseFile(fo) 
	
	CopyFile cpfsrc$, cpfdes$ 
	
	reloadModel()
	
End Function

;--------------------

Function reloadModel()
	
	If mesh <> 0 Then FreeEntity mesh
	mesh = LoadAnimMesh(mdlpath$, meshpiv)
	ExtractAnimSeq( mesh,0,30 ) ;anim sequence 1: frames 0...30 are 'walk'
	ScaleEntity mesh, meshScale[0], meshScale[1], meshScale[2], 1
	
End Function

;--------------------

Function txtButton(part$, posX, posY)
	
	farbe("dunkel")
	Rect posX, posY, StringWidth(part$) + 4, 10+4, 1
	farbe("beige")
	Rect posX+1, posY+1, StringWidth(part$) + 2, 10+2, 1
	farbe("mittel")
	Text posX+2, posY, part$
	farbe("weiss")
	
	If MausX > posX And MausX < (posX + StringWidth(part$) + 2) And MausY > posY And MausY < (posY + 14) Then
		If Maus1Hit Then 
			swapTexture(part$, 1) ;weiter
		ElseIf Maus2Hit Then 
			swapTexture(part$, -1) ;zurck
		EndIf
	EndIf

End Function

;--------------------

Function progressBar(max, now, msg$)
	
	farbe("dunkel")
	Rect resX/2-100, resY/2, 200, 14, 1
	farbe("hell")
	Rect resX/2-100+2, resY/2+2, 200-4, 10, 1
	
	farbe("gelb")
	Local maxP = 200-4
	Local nowP# = Float(maxP)/max*now
	Rect resX/2-100+2, resY/2+2, nowP#, 10, 1
	
	farbe("dunkel")
	Text resX/2-StringWidth(msg$)/2, resY/2, msg$
	farbe("weiss")
	
	WaitTimer(Timer) ; 60Fps
	Flip(0)
	
End Function
	
;--------------------
;~IDEal Editor Parameters:
;~C#Blitz3D